"""
liste d'entiers, accessibles par multiples de 2 et multiples de 3.
"""
# rappel: data_tycat affiche un vecteur d'objets.
# @trace permet de tracer les appels d'une fonction.
# tous deux ne fonctionnent que dans terminology.
# vous n'etes pas obliges de les utiliser.
# from tycat import data_tycat, trace

# remplacez par vos identifiants
NOM = "mon_nom"
PRENOM = "mon_prenom"
GROUPE = -1
assert NOM != "mon_nom", "veillez remplacer 'mon_nom' par votre nom"
assert PRENOM != "mon_prenom", "veillez remplacer 'mon_prenom' par votre prenom"
assert isinstance(GROUPE, int) and 1 <= GROUPE <= 8, \
    "veuillez entrer votre numero de groupe"

DIVISEURS = [2, 3]

class Cellule:
    """
    une cellule de nos listes contient une valeur entiere
    et deux references dans un tableau:
        vers la cellule paire suivante,
        vers la cellule multiple de 3 suivante
    """
    #pylint: disable = too-few-public-methods
    def __init__(self, valeur):
        self.valeur = valeur
        self.suivants = [None, None]

class Liste:
    """
    une liste d'entiers entrelacant cellules paires et multiples de trois.
    """
    def __init__(self):
        """
        cree une liste vide avec une sentinelle de tete contenant 0.
        """
        self.tete = Cellule(0)

    def cellules(self, index):
        """
        generateur permetant d'iterer sur toutes les cellules paires
        ou sur toutes les cellules multiples de trois (incluant 0).
        Par exemple liste_test().cellules(0) doit iterer sur les cellules contenant
        0 puis 2 puis 6 puis 8.
        liste_test().cellules(1) doit iterer sur les cellules contenant
        0 puis 3 puis 6.
        """
        #TODO
        pass

    def peupler(self, iterable):
        """
        remplit une liste vide a partir des donnees de l'iterable donne.
        renvoie la liste.
        pre-conditions :
            - la liste est vide (en dehors de 0)
            - les valeurs de l'iterable sont par ordre croissant
            - les valeurs de l'iterable sont toutes des multiples de 2 ou 3, sans doublons
        """
        #TODO
        return self  # ne pas effacer

    def insertion(self, valeur):
        """
        insere une valeur donnee a la bonne place dans la liste.
        renvoie la liste.
        pre-conditions:
            - la valeur donnee est forcement multiple de 2 et/ou 3
            - la valeur donnee n'est pas deja dans la liste
        """
        #TODO
        return self  # ne pas effacer

    def suppression(self, valeur):
        """
        supprime la cellule contenant la valeur donnee.
        renvoie la liste.
        pre-conditions:
            - la liste possede une cellule contenant la valeur donnee.
            - on ne supprime pas 0
        """
        #TODO
        return self  # ne pas effacer

    def parcours(self):
        """
        itere sur chaque cellule, de la plus petite valeur a la plus grande.
        Par exemple liste_test().parcours() doit iterer sur les cellules contenant
        0 puis 2 puis 3 puis 6 puis 8.
        On rappelle que l'on ne doit faire qu'un seul passage.
        Interdiction donc de tout convertir en 2 vecteurs puis de re-parcourir les vecteurs.
        """
        #TODO
        pass


def liste_test():
    """
    cree manuellement la liste 0, 2, 3, 6, 8.
    Celle-ci est utilisable pour des tests.
    """
    liste = Liste()
    cel2, cel3, cel6, cel8 = [Cellule(v) for v in (2, 3, 6, 8)]
    # derriere 0: 2 et 3
    liste.tete.suivants[0] = cel2
    liste.tete.suivants[1] = cel3
    # derriere 2: 6
    cel2.suivants[0] = cel6
    # derriere 3: 6
    cel3.suivants[1] = cel6
    # derriere 6: 8
    cel6.suivants[0] = cel8
    return liste
